<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlarmScreenNg: $title</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlarmScreenNg
   &#160;<span id="projectnumber">0.9.2</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="pages.html"><span>Related&#160;Pages</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="PageDoc"><div class="contents">
<div class="textblock"><h1><a class="anchor" id="secPurpose"></a>
The purpose of this document</h1>
<p>This document contains information on operation and configuration of the NextGen Alarm Screen (NG AS). The NG AS is replacing the existing AES of WinCC OA. Like the AES in WinCC OA, the NG AS acts as a common foundation for different framework- and application-specific alarm screens.</p>
<h1><a class="anchor" id="secFeatures"></a>
Main features of the Alarm Screen</h1>
<p>The main purpose of the Alarm Screen is to provide a means for experts to observe the current state of alarms in the system, as well as investigate development of alarm states in the past. Alarms are displayed as rows in a table, with every column displaying different alarm properties. The set of columns is configured according to the requirements of the framework/system. There are two major modes of AS operation:</p><ul>
<li>Live mode that displays the alarms that are currently active in the controlled system.</li>
<li>History mode that displays the alarms that appeared in the past and were stored in the archive.</li>
</ul>
<p>In both modes, the user has the possibility to filter the set of displayed alarms based on the values of alarm properties; the set of available properties for filtering is configurable. Whenever possible, filter widgets use completers, providing the user with meaningful completion for strings as they are edited. Filter settings can be persisted for future use. Furthermore, it is possible to view the number of active alarms, matching any saved filter, in a very compact form, without seeing all the details of matching alarms - just their number. The overview of the controlled system can be built by combining several of such prepared filters.<br  />
</p>
<p>The end user has a wide range of features for configuring the AS according to their particular needs, including the set of columns displayed in the table, the order of rows in the table, the default filter, etc. In addition, a hierarchical tree view (with alarms grouped by different properties at different levels of the tree) can be used instead of a flat table if such approach better suits the requirements. The prepared set of user settings can be persisted Several sets of user settings can be stored, and one of them can be nominated to be the default which is used when the AS is started.<br  />
</p>
<p>Originally, the AS comes with all configuration features available to all users. However, the admin can configure the access rights such that certain features are available only to a selected group of users.</p>
<h1><a class="anchor" id="secImprovements"></a>
Improvements as compared to the previous solution</h1>
<p>The previous solutions used at CERN are based on the built-in AES of WinCC OA. The major improvements brought by the new solution are the following:</p>
<ul>
<li>
The basic implementation uses C++, which is expected to result in better performance, especially on tables with many alarms.  </li>
<li>
More flexible and user-friendly configuration: 'almost human-readable' JSON format is used for all types of configurations. The whole configuration is stored in just one DPE, so the set of DPEs doesn't need to be extended when new functionality is added.  </li>
<li>
Unified approach to customization of running alarm screen, including admin and user settings. It is expected that a single set of configuration tools shall fulfill the needs of all project types.  </li>
<li>
The possibility of very precise configuration of the alarm screen's appearance, including disabling or hiding certain elements based on the access rights of the current user.  </li>
<li>
Relatively easy extension of the set of columns displayed in the alarm table: the basic implementation includes the most important properties of alarms; more can be added by plugins(s) written in C++. The basic implementation includes plugins for JCOP and UNICOS; their code can be used as the base for creating other plugins.  </li>
<li>
Similar plugin mechanism is used for building queries to retrieve alarms from ORACLE archives; more plugins can be added if some specific data needs to be retrieved from archive.  </li>
</ul>
<h1><a class="anchor" id="secTerms"></a>
Terms</h1>
<p>The basic terms used throughout the documentation are introduced in this section.</p>
<h2><a class="anchor" id="subSecAlarm"></a>
Alarm</h2>
<p>The interpretation of 'an alarm' by WinCC OA may not meet intuitive expectations. Let's consider a simple example: a door that must normally be closed. There is a big red lamp which turns on when the door is opened. The alarm condition for this case is: 'the door is open'.</p>
<div class="image">
<img src="doorAlarm.png" alt=""/>
<div class="caption">
Door alarm example</div></div>
 <p>The plot above displays the state of the door as a function of time: the green line corresponds to the closed door (normal state), the red line corresponds to the opened door (alarm state).</p>
<p>One could consider the red state on the plot above to be 'an alarm'. However, for WinCC OA 'an alarm' is not a <b>state</b>, but rather an <b>event</b>: a transition between a good and a bad state (or vice versa). Thus, from the WinCC OA point of view, there are two alarms on the plot above, corresponding to two transitions at moments <b>t1</b> and <b>t2</b> (the blue lines on plot):</p><ul>
<li><b>CAME</b> alarm at time <b>t1</b>, and</li>
<li><b>WENT</b> alarm at time <b>t2</b></li>
</ul>
<p>These two alarms are physically and logically linked to each other: they represent the transitions between good and bad state for the same physical object (the door). Furthermore, the WENT alarm at time t2 is the end of the life cycle for the 'bad state', started by the CAME alarm at time t1. Such linked CAME and WENT alarms form an <b>alarm pair</b>. Internally, every alarm object of a pair has a reference to its <b>partner</b>: a WENT alarm has a reference to its CAME alarm, and the CAME alarm has a reference to the WENT alarm (if any).</p>
<p>More detailed information on alarms in WinCC OA, their logic, configuration and attributes can be found in the WinCC OA Online Help.</p>
<h2><a class="anchor" id="subSecAlarmProps"></a>
Alarm properties</h2>
<p>The Alarm Screen displays alarms as rows in a table, with the columns displaying different <b>alarm properties</b>. The set of available properties includes:</p>
<ul>
<li>
Limited subset of attributes of the <b>_alert_hdl</b> config. This includes: DPE name, alarm time, alarm text, alarm priority, alarm color, etc.  </li>
<li>
The values, calculated from the attributes of _alert_hdl config. For example, the <b>_comment</b> attribute is used to calculate the total number of comments attached to the alarm, to be shown in the table.  </li>
<li>
The values which are not taken from the attributes of the _alert_hdl config, but rather from other sources. Some examples: DP/DPE alias, description, device type etc.  </li>
</ul>
<p>All alarm properties, displayed by the Alarm Screen in a particular project, are composed of two parts:</p>
<ul>
<li>
Basic properties, which are a part of the basic implementation. They are available in all projects where the NG AS is used, and they cannot be removed  </li>
<li>
In addition, every project can add its own properties. This is a relatively easy task, but it requires C++ coding (at least in the current version of the NG AS)  </li>
</ul>
<h2><a class="anchor" id="subSecPropertySource"></a>
Alarm property source</h2>
<p>Taking into account that alarms are naturally joined in pairs (see <a class="el" href="Introduction.html#subSecAlarm">Alarm</a>), it is a common practice to display just one row in the table for a pair of alarms. In such cases, it can be desirable to mix the values of properties of both CAME and WENT alarms in a table row.</p>
<p>In order to handle such use cases, the <b>source</b> of value has been introduced. Thus, when deciding what values shall be shown in table, one can select not only what property is to be shown in a particular column, but also from which alarm of a pair that property shall be read. Four types of sources have been introduced:</p>
<ul>
<li>
<b>this</b>: the value of a property for the 'main' alarm is shown in the table column  </li>
<li>
<b>partner</b>: the value of a property for the partner of the 'main' alarm is shown in the table column  </li>
<li>
<b>came</b>: the value of a property for the CAME alarm is shown in the table column, independently on what is the 'main' alarm for the table row  </li>
<li>
<b>went</b>: the value of a property for the WENT alarm is shown in the table column, independently on what is the 'main' alarm for the table row  </li>
</ul>
</div></div><!-- contents -->
</div><!-- PageDoc -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
